# Define the stack class
#  stackVar:	Contains the list of items in the stack

::oo::class create stack {
    
    variable stackVar
    
    # stackVar is a per-object variable.
    # The method to push data onto the top of a stack
    #
    # Arguments
    #  value	    A value to push onto the stack
    
    method push { value } {
        lappend stackVar $value
    }
    
    # The method to pop data off the top of a stack
    
    method pop { } {
        set rtn [lindex $stackVar end]
        set stackVar [lrange $stackVar 0 end-1]
        return $rtn
    }
}

# Example 2
# Using a Class

# Create a new object named*_st'
stack create st

# Push values onto the*_st' stack
st push "value 1"
st push "value 2"

# Pop and display
puts [st pop]


