oo::class create logFile {
    variable channel
    
    # invoked when an object is created
    # Arguments
    #  name	The pathname of the log file to open
    
    constructor { name } {
        set channel [open $name w]
    }
    
    # invoked when an object is destroyed
    destructor {
        close $channel
    }
    
    # A method to send data to a channel
    # Arguments
    #  data	The text to write to the log file.
    
    method write { data } {
        puts $channel $data
    }
    
}

# Example 4
# Using a Class with Constructor and Destructor

logFile create captLog ./captLog.txt
captLog write "Captain's Log,Stardate [clock seconds]"

captLog write "I wish something exciting would happen."
captLog destroy

set medicalLog [logFile new ./medLog.txt]
$medicalLog write "The captain is showing signs of boredom"
$medicalLog write "Initiating Kobyashi Maru scenario."
$medicalLog destroy

